:: this batch permits right-clicking HP21xx .asm files and assembling them
:: with HPASM.EXE, after assembly an 8-byte leader is added to the binary
:: and the output files renamed with the same basename as the source file.
:: To set up copy asmhpasm.bat, ptleader.bin and HPASM.EXE to the directory
:: C:\hp2100bat or edit below to specify different locations.
@echo off
::--- edit below to set up -----------
set asm=C:\hp2100bat\hpasm.exe
set ptheader=C:\hp2100bat\ptheader.bin
set asmout=hpasm.out
set asmlst=hpasm.lst
::------------------------------------
if exist %1 goto checkbin
echo Asm file %1 not found
pause
goto end
:checkbin
if exist %ptheader% goto doit
echo PT header %ptheader% not found
pause
goto end
:doit
%asm% %1
if not exist %asmout% goto asmerror
if not exist %asmlst% goto asmerror
:: determine base name of asm file...
md asmhpasm.tmp
copy %1 asmhpasm.tmp\*. > nul
if exist asmhpasm.tmp\*. goto doit2
rd asmhpasm.tmp
echo Can't determine base name
pause
goto end
:doit2
cd asmhpasm.tmp
for %%a in (*) do set base="%%a"
cd ..
del asmhpasm.tmp\*.
rd asmhpasm.tmp
copy /b %ptheader% + %asmout% %base%.abs > nul
copy %asmlst% %base%.lst > nul
if not exist %base%.abs goto renerror
if not exist %base%.lst goto renerror
echo Output copied to %base%.abs and %base%.lst
del %asmout%
del %asmlst%
goto end
:asmerror
echo Assembler output %asmout% or %asmlst% not found
pause
goto end
:renerror
echo Something went wrong renaming output files
pause
:end
